# -*- coding: utf-8 -*-

"""
    Toronto-Channels Add-on
    Author: Twilight0

        This program is free software: you can redistribute it and/or modify
        it under the terms of the GNU General Public License as published by
        the Free Software Foundation, either version 3 of the License, or
        (at your option) any later version.

        This program is distributed in the hope that it will be useful,
        but WITHOUT ANY WARRANTY; without even the implied warranty of
        MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
        GNU General Public License for more details.

        You should have received a copy of the GNU General Public License
        along with this program.  If not, see <http://www.gnu.org/licenses/>.
"""

import os, sys
import urllib, urlparse
import xbmc, xbmcaddon
import xbmcgui, xbmcplugin

# Addon variables:
join = os.path.join
Addon = xbmcaddon.Addon()
Player = xbmc.Player().play
language = Addon.getLocalizedString
addonname = Addon.getAddonInfo("name")
addonid = Addon.getAddonInfo("id")
addonpath = Addon.getAddonInfo("path")
addonfanart = Addon.getAddonInfo("fanart")
#addondesc = language(30000).encode("utf-8")
#datapath = xbmc.translatePath(Addon.getAddonInfo("profile")).decode("utf-8")

# Misc variables:
addonicon = join(addonpath, 'icon.png')
addonart = join(addonpath, 'resources/media')
NETVToronto_img = join(addonart, 'NETV_Toronto.png')
Cannali_img = join(addonart, 'CANNALI_WEB_MUSIC.png')
Melodia_img = join(addonart, 'RADIO_MELODIA_TORONTO.png')
Settings_img = join(addonart, 'settings.png')
NETVToronto_url = 'rtmp://live.netvtoronto.com/NetvToronto/NetvToronto'
Cannali_url = 'rtmp://live.streams.ovh/cannali/cannali'
Melodia_url = 'http://149.202.208.214:9086/live'

# Handlers:
addon_url = sys.argv[0]
addon_handle = int(sys.argv[1])
args_handler = urlparse.parse_qs(sys.argv[2][1:])


# Function to build addon's url
def params(query):
    return addon_url + '?' + urllib.urlencode(query)

action = args_handler.get('action', None)


def main_menu():

    if Addon.getSetting('auto-view') == 'true':
        xbmc.executebuiltin('Container.SetViewMode(500)')
    elif Addon.getSetting('auto-view') == 'false':
        pass

    # NETV Toronto
    if Addon.getSetting('netv') == 'true':
        netv_url = params({'action': 'play', 'item': NETVToronto_url})
        netv_li = xbmcgui.ListItem(label='NETV Toronto')
        netv_li.setArt({'icon': NETVToronto_img, 'fanart': addonfanart})
        xbmcplugin.addDirectoryItem(handle=addon_handle, url=netv_url, listitem=netv_li, isFolder=False)
    elif Addon.getSetting('netv') == 'false':
        pass

    # Cannali Music
    if Addon.getSetting('cannali') == 'true':
        cannali_url = params({'action': 'play', 'item': Cannali_url})
        cannali_li = xbmcgui.ListItem(label='CANNALI Music')
        cannali_li.setArt({'icon': Cannali_img, 'fanart': addonfanart})
        xbmcplugin.addDirectoryItem(handle=addon_handle, url=cannali_url, listitem=cannali_li, isFolder=False)
    elif Addon.getSetting('cannali') == 'false':
        pass

    # Radio Melodia Toronto
    if Addon.getSetting('melodia') == 'true':
        melodia_url = params({'action':  'play', 'item': Melodia_url})
        melodia_li = xbmcgui.ListItem(label='Radio Melodia Toronto')
        melodia_li.setArt({'icon': Melodia_img, 'fanart': addonfanart})
        xbmcplugin.addDirectoryItem(handle=addon_handle, url=melodia_url, listitem=melodia_li, isFolder=False)
    elif Addon.getSetting('melodia') == 'false':
        pass

    # Settings
    settings_url = params({'action': 'settings'})
    settings_li = xbmcgui.ListItem(label='Settings')
    settings_li.setArt({'icon': Settings_img, 'fanart': addonfanart})
    xbmcplugin.addDirectoryItem(handle=addon_handle, url=settings_url, listitem=settings_li, isFolder=True)

    xbmcplugin.endOfDirectory(addon_handle)


def play_item():

    url = args_handler['item'][0]

    if url == NETVToronto_url:
        _list_item = xbmcgui.ListItem(label='NETV Toronto')
        _list_item.setInfo('video', {'title': 'NETV Toronto'})
        Player(url, _list_item)

    elif url == Cannali_url:
        _list_item = xbmcgui.ListItem(label='CANNALI Music')
        _list_item.setInfo('video', {'title': 'CANNALI Music'})
        Player(url, _list_item)

    elif url == Melodia_url:
        _list_item = xbmcgui.ListItem(label='Radio Melodia Toronto')
        _list_item.setInfo('video', {'title': 'Radio Melodia Toronto'})
        _list_item.setArt({'fanart': addonfanart})
        Player(url, _list_item)


if action is None:

    main_menu()

elif action[0] == 'play':

    play_item()

elif action[0] == 'settings':

    Addon.openSettings()
